////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RadioJet
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#ifndef _DEFS
#define _DEFS

#pragma pack(push)
#pragma pack(1)

#define USHORT unsigned short
#define UBYTE unsigned char

#define	DEC_AUDIO	0
#define DEC_CW		1
#define DEC_FAX		2
#define	DEC_RTTY	3
#define	DEC_SSTV	4
#define	DEC_TIMES	8

#define	DEC_SITOR	13
#define	DEC_R88		14
#define	DEC_PSK		15

//IF-1102S Modies
#define REC_LSB		(0x00000001)   
#define REC_USB		(0x00000002)   
#define REC_CW		(0x00000008)   
#define REC_AM		(0x00000080)   
#define REC_FM		(0x00001000)
#define REC_WFM		(0x00002000)
#define REC_DRM		(0x20000000)
#define REC_AMSS	(0x40000000)

#define MODE_LSB	0   
#define MODE_USB	1  
#define MODE_CW		2
#define MODE_AM		3  
#define MODE_FM		4
#define MODE_WFM	5
#define MODE_AMSS	6
#define MODE_DRM	7


//Channel work modies
#define RTTY_MODE_BAUDOT		0x0000
#define RTTY_MODE_BAUDOTSYNC	0x0001
#define RTTY_MODE_SITORB		0x0002
#define RTTY_MODE_ASCII_7		0x0003
#define RTTY_MODE_ASCII_8		0x0004
#define RTTY_MODE_FEC_A			0x0005
#define RTTY_MODE_SYNOP			0x0010
#define RTTY_MODE_NAVTEX		0x0012
#define RTTY_MODE_ASCII_7P		0x0023
#define RTTY_MODE_ASCII_8P		0x0024

#define	RTTY_MODE_BPSK31		0x0101
#define RTTY_MODE_QPSK31		0x0102
#define RTTY_MODE_QPSK31Inv		0x0103
#define	RTTY_MODE_CW			0x0800
#define	DEFAULT_MODE			0x0FFF

// radio modulation for frquency list
#define RADIO_MODE_LSB		0	//(0x00000001)
#define RADIO_MODE_USB		1	//(0x00000002)
#define RADIO_MODE_CWN		2	//(0x00000004)
#define RADIO_MODE_CW		3	//(0x00000008)
#define RADIO_MODE_RTTY		4	//(0x00000010)
#define RADIO_MODE_FAX		5	//(0x00000020)
#define RADIO_MODE_AMN		6	//(0x00000040)
#define RADIO_MODE_AM		7	//(0x00000080)
#define RADIO_MODE_ASD		8	//(0x00000100)
#define RADIO_MODE_ASF		9	//(0x00000200)
#define RADIO_MODE_ASL		10	//(0x00000400)	
#define RADIO_MODE_ASU		11	//(0x00000800)
#define RADIO_MODE_FM		12	//(0x00001000)
#define RADIO_MODE_WFM		13	//(0x00002000)
#define RADIO_MODE_ATT		14	//(0x00004000)
#define RADIO_MODE_ZFW		15	//(0x00008000)
#define RADIO_MODE_VOLUME	16	//(0x00010000)
#define RADIO_MODE_SQUELCH	17	//(0x00020000)
#define RADIO_MODE_AGC		18	//(0x00040000)
#define RADIO_MODE_NB		19	//(0x00080000)
#define RADIO_MODE_ANT		20	//(0x00100000)
#define RADIO_MODE_SMETER	21	//(0x00200000)
#define RADIO_MODE_IFSHIFT	22	//(0x00400000)
#define RADIO_MODE____		23	//(0x00800000)
#define RADIO_MODE_PREAMP	24	//(0x01000000)
#define RADIO_MODE_SAM		25	//(0x02000000)
#define RADIO_MODE_AMS		26	//(0x04000000)
#define RADIO_MODE_ISB		27	//(0x08000000)
#define RADIO_MODE_DSB		28	//(0x10000000)
#define RADIO_MODE_DRM		29	//(0x20000000)
#define RADIO_MODE_AMSS		30	//(0x40000000)


typedef	CArray<USHORT,USHORT&> SortIndex;

typedef struct
				{
				char		A3[4];
				char		A2[4];
				char		Name[50];
				int			shortNumber;
				int			longNumber;
				}LNGCODE;
typedef	CArray<LNGCODE,LNGCODE&> LNG_List;

typedef struct
				{
				char		A3[4];
				char		A2[4];
				char		Name[50];
				int			Number;
				int			sort;
				int			item;
				}ISOCODE_A;
typedef	CArray<ISOCODE_A,ISOCODE_A&> IsoList;

typedef struct
				{
				char		A3[4];
				char		Name[112];
				int			Number;
				}ISOCODE_B;
typedef	CArray<ISOCODE_B,ISOCODE_B&> IsoBList;

typedef struct
				{
				char		city[4];
				char		country[4];
				char		Name[50];
				int			lon;
				int			lat;
				int			Number;
				}SITECODE;
typedef	CArray<SITECODE,SITECODE&> SiteList;


typedef struct	{
				double	frq;
				char	name[32];
				int		decoder;
				int		modulation;
				char	call[16];
				int		country;
				int		stationtype;
				int		steps;
				int		IF;
				double	txfrq;
				BOOL	att;
				BOOL	agc;
				BOOL	nb;
				int		volume;
				int		squelch;
				double	startfrq;
				double	stopfrq;
				int		scansteps;
				BOOL	wave_onoff; 
				BOOL	line_onoff; 
				BOOL	dec_filter; 
				BOOL	antenna; 
				char	equ_filter_name[16];
				int		wave_out_vol;
				int		line_in_vol;
				int		line_out_vol; 
				int		audio_squelch;
				int		scanrec;
				int		scansqlstop;
				int		rectime;
				int		scanwhiletime;
				int		scanausq;
				BOOL	assume_radio; 
				BOOL	assume_audio; 
				int		flags;
				int		CW_center;
				int		CW_mark;
				int		CW_width;
				int		FAX_modul;
				int		FAX_speed;
				int		FAX_centerfrq;
				int		FAX_shift;
				int		FAX_filtermode;
				int		FAX_filterwidth;
				int		FAX_hmirror;
				int		FAX_vmirror;
				int		FAX_amfm;
				int		FAX_filteronoff;
				int		FAX_burst1;
				int		FAX_burst2;
				int		FAX_syncwidth;
				int		FAX_invertsync;
				int		RTTY_mode;
				int		RTTY_baud;
				int		RTTY_mark;
				int		RTTY_space;
				double	RTTY_stopbits;
				int		RTTY_polarity;

				union
					{
					int		SSTV_mode; 
					int		SSTV_vis; 
					};
				union
					{
					int		SSTV_filterlofrq;
					int		SSTV_synfrq;
					};
				union
					{
					int		SSTV_filterhifrq;
					int		SSTV_filterwidth;
					};
				union
					{
					int		SSTV_filterorder;
					int		SSTV_filtertype;
					};
				union
					{
					int		SSTV_manual_filtemode;
					int		SSTV_filter_onoff;
					};

				char	Commentary[80];
				int		modulationtype;
				int		SatID;
				int		TimerStartTime;
				int		TimerStopTime;
				union
					{
					int		Extension_3;
					char	NAVTEX_RegLetter;
					};
				int		equ_filter;		
				}OLD_FRQLISTSET;
typedef struct	{
				UINT	CountryIdx:10;		//received index of the country list
				UINT	LanguageIdx:9;		//received index of the language list
				UINT	DataAudioTypeIdx:4;	//received index of the DataAudio StringArray
				UINT	ProgrammTypeIdx:5;	//received index of the program type list
				UINT	CodecTypeIdx:4;		//received index of the codec type StringArray
				UINT	iServiceID;			//the ID of the Service
				}FRQ_DRM_SET;

typedef struct	{
				UINT	rectype:1;
				UINT	hold_on_silenc:1;	
				UINT	hold_on_snr:1;
				UINT	hold_on_sql:1;
				UINT	filter_bypass:1;
				UINT	sql_val:8;
				UINT	snr_val:8;
				UINT	reserve;
				}FRQ_AUDIO_SET;

typedef struct	{
				UINT	modul:16;
				UINT	speed:16;
				UINT	centerfrq:16;
				UINT	shift:16;
				UINT	filterwidth:16;
				UINT	burst1:16;
				UINT	burst2:16;
				UINT	syncwidth:8;
				UINT	filtermode:3;
				UINT	hmirror:1;
				UINT	vmirror:1;
				UINT	amfm:1;
				UINT	filteronoff:1;
				UINT	invertsync:1;
				UINT	SatID;
				}FRQ_FAX_SET;

typedef struct	{
				UINT	mode:16; 
				UINT	synfrq:16;
				UINT	filterwidth:16;
				UINT	filtertype:8;
				UINT	filter_onoff:1;
				}FRQ_SSTV_SET;

typedef struct	{
				UINT	mark:16;
				UINT	space:16;
				UINT	mode:16;
				UINT	baud:9;
				UINT	stopbits:5;
				UINT	polarity:1;
				UINT	revers_shif:1;	
				UINT	reserveflag:1;
				UINT	RegionNr:7;
				char	RegLetter;
				}FRQ_RTTY_SET;

typedef struct	{
				UINT	width:16;
				UINT	mode:15;
				UINT	afc:1;
				UINT	center:16;
				UINT	mark:16;
				}FRQ_CW_SET;

typedef struct	{
				UINT	m_mode:16;
				UINT	center:16;
				}FRQ_TIME_SET;

typedef struct	{
				UINT	sch_time_Start:11;	
				UINT	sch_time_Stop:11;
				UINT	sch_time_Days:7;
				UINT	sch_time_flag:3;
				}SCH_TIME_SET;

//frq workflags
#define FRQ_RADIO_PARA		1
#define FRQ_IF_FILTER		2
#define FRQ_DEC_FILTER		4
#define FRQ_EQU_FILTER		8

#define FRQ_DAYS_SU	0x40
#define FRQ_DAYS_MO	0x20
#define FRQ_DAYS_TU	0x10
#define FRQ_DAYS_WE	0x08
#define FRQ_DAYS_TH	0x04
#define FRQ_DAYS_FR	0x02
#define FRQ_DAYS_SA	0x01
#define FRQ_DAYS_ALL 0x7F

#define FRQ_TIME_FLAG_UTCIN 1

//Bank view defaults
#define FRQ_DECODER_SET		0x01  
#define FRQ_METEO_SET		0x02
#define FRQ_HAMRADIO_SET	0x04
#define FRQ_DRMSET			0x08
#define FRQ_OLDSET			0x80

typedef struct	{
				char	languageNullByte;
				char    sec[13];
				char    fmt[13];
				char    reserve[5];
				}FRQ_BEACON_SET;

typedef struct	{
				char	location[24];
				UINT	FrqID;
				UINT	extraFlag:16;	//is set all times 0x99FF as Marker 
				UINT	langNumber:16;
				}EXTRAINFO;

typedef struct	{
				UINT	frq;		
				UINT	FrqSetID;
				UINT	FrqUserID;
				time_t	FrqSetDate;
				short	lon;
				short	lat;

				char	name[32];
				char	call[16];
				union
					{
					char	language[32];
					FRQ_BEACON_SET beacon;
					};
				union
					{
					char	location[32];
					EXTRAINFO extraInfo;
					};
				char	Commentary[81];

				UINT	xFrqSetID;
				UINT	xFrqUserID;
				UINT	xFrqBase:8;
				UINT	xWorkFlag:1;
				char	xreserve;

				UINT    StationsNr:17;
				USHORT	IFCenterOnDecoder:1;
				USHORT  RegionNr:4;
				USHORT	height:11;  //height in 5 meter steps
				USHORT  PWR;
				USHORT  AZM;
				union
					{
					char	ADM[4];
					char	ITU[4];
					};

				USHORT	steps;
				USHORT	IFBandwidth;
				USHORT	decoder;
				
				UINT	FrqFlags:4;
				UINT	TimerFlags:3;
				UINT	workflags:4;	//1=set radio para | 2=if_filter | 4=dec_filter | 8=equ_filter
				UINT	FilterNoDec:7;
				UINT	FilterNoIF:7;
				UINT	FilterNoEqu:7;

				UINT	country:16;
				UINT	modulation:5;		//USB/LSB/AM/FM....
				UINT	modulationtype:5;
				UINT	stationtype:5;
				UINT	reserve:1;			//intern use for date schedule has changed / after new creation of source data

				//radio para	
				UINT	att:2;
				UINT	alc:1;
				UINT	inputchannel:2;			
				UINT	saveAudio:1;
				UINT	saveIF:1;
				UINT	Antenna1:1;		//bit 0 and 1 = Antenna-X / Bit 2= UKW-Converter 136MHz  Bit 3= Sat-Converter 136MHz  Bit 4= 2Meter-Converter  Bit 5= 70cm-Converter  
				UINT	Antenna2:1;
				UINT	Switch1:1;
				UINT	Switch2:1;
				UINT	Switch3:1;
				UINT	ConvUHF:1;
				UINT	ConvSAT:1;
				UINT	Conv2m:1;
				UINT	Conv70cm:1;
				UINT	volume:8;
				UINT	squelch:8;
				
				FRQ_DRM_SET		drm;
				FRQ_AUDIO_SET	audio;
				FRQ_FAX_SET		fax;
				FRQ_SSTV_SET	sstv;
				FRQ_RTTY_SET	rtty;
				FRQ_CW_SET		cw;
				FRQ_TIME_SET	time;
				SCH_TIME_SET	schSet;

				}FRQLISTSET;

/*typedef struct	{
				int		FrqSetID;
				int		FrqSetDate;
				BYTE	FrqSourceID;
				BYTE	SchSourceID;
				short	lastupdate;	
				union
					{
					int		SchFrameID;
					int		NavFrameID;
					int		WebFrameID;
					int		SatFrameID;
					};
				}FRQLISTHEAD;*/

typedef struct	{
				UINT	SchSetID;			//Schedule ID
				UINT	SchLink:16;			//Link Pointer for the Schedule handling
				UINT	SchWork:16;			//WorkFlags for the Schedule handling
				UINT	FrqBase:4;			//pointer to the  list of currend active Source File List (FrqSourceList - FRQSORCEHEADER array)
				UINT	FrqBaseFlag:4;		//workflag  FRQ_DATA_OK,FRQ_DATA_OLD,FRQ_DATA_NEW
				UINT	show:1;				//hide item = 1 show item =0
				UINT	FrqBankSelect:8;	//a bit matrix for viewing in the frq bank list bit1-6 = bank 
											//and Bit-0 is not in use (main base views all times all entrys)
											//and Bit-7 is not in use (user base views all times all user entrys)

				union
					{
					int		SchFrameID;		//Schedule frame pointer  
					int		NavFrameID;
					int		WebFrameID;
					int		SatFrameID;
					};
				}FRQLISTHEAD;


#define		FRQ_DELETE		0x01	//compare with old reference was equal, you must delete this item
#define		FRQ_DATE_CHNG	0x02	//only the date is different
#define		FRQ_NEW_ITEM	0x04	//not 0x04, then it is the old item (FRQ_OLD_ITEM)
#define		FRQ_	0x08

typedef struct	{
				FRQLISTSET	db;
				FRQLISTHEAD	dh;
				BYTE		WorkFlag;
				}FRQLISTDAT;

typedef struct	{
				int		FrqItem;
				UINT	FrqSetID;
				UINT	FrqUserID;
				time_t	FrqSetDate;
				}FRQBANKSET;

typedef struct	{
				UINT	frq;		
				short	lon;
				short	lat;
				char	name[32];
				USHORT	IFBandwidth;
				USHORT	decoder;
				UINT	country:16;
				UINT	modulation:5;		//USB/LSB/AM/FM....
				UINT	modulationtype:5;
				UINT	stationtype:5;
				UINT	reserve:1;
		SCH_TIME_SET	schSet;
				}FRQCMP;

typedef CArray<FRQCMP,FRQCMP&> FrqCMP;

typedef CArray<FRQBANKSET,FRQBANKSET&> FrqBankSet;
typedef CArray<FRQLISTDAT,FRQLISTDAT&> FrqListData;
typedef CArray<int,int&> FrqListSort;

typedef struct	{
				OLD_FRQLISTSET	db;
				FRQLISTHEAD	dh;
				char		res[512-sizeof(OLD_FRQLISTSET)-sizeof(FRQLISTHEAD)];
				}OLDFRQLISTDAT;

typedef CArray<OLDFRQLISTDAT,OLDFRQLISTDAT&> OldFrqListData;

typedef struct
				{
				int		FrqSetID;			//IDentfy of the FrqSet in the FrqList
				int		PointerToFrqList;	//realy pointer the entry (FrqSet) of the FrqList
				int		frqnum;				//frq in Hz
				int		Emission;			//Type of Emisson 
				int		Power;				
				int		SenderTimeBegin;
				int		SenderTimeEnd;
				int		SenderYearTimeBegin;
				int		SenderYearTimeEnd;
				char	SenderTimeText[64];
				char	CallSign[10];
				}SCHFRQSET;


typedef struct
				{
				int		SchFrameID;
				int		RegionNr;
				int		StationsCountryNr;
				int		StationsNr;
				int		StationsLon;
				int		StationsLat;
				char	StationsName[64];
				int		ScheduleFrqSize;	//max 16 FrqSet's
		   SCHFRQSET	FrqSet[16];
				int		ScheduleStartItem;	//Startpointer to the Entrys
				int		ScheduleEndItem;	//Endpointer to the Entrys
				time_t	LastUpdate;
				char	WebUpdate[256];
				int		BroadcastSchedule_RPM;
				int		BroadcastSchedule_IOC;
				int		BroadcastSchedule_TM1;
				int		BroadcastSchedule_TM2;
				char	BroadcastSchedule_TXT[98];
				int		flags;
				} SCHFRAMESET;



typedef	struct	{
	short	x;
	short	y;
} COORDIANTE; 
typedef	CArray<COORDIANTE,COORDIANTE&>	Coordinates;


#define	MAXFTPREAD	0x400

#define REPEATATION 3
#define MAXREAD 0x400

#define SERVER_NOT_OK	-1
#define URL_NOT_OK		-2
#define URL_PEX_ERR		-3
#define URL_WROPEN_ERR	-4
#define SERVER_NOT_OK	-1
#define	URL_SESION_CREATE_ERR -6
#define	URL_READ_ERR -7
#define	URL_SEEK_ERR -8
#define PROG_STOPP	-9
#define FILE_NULL_ERR -15
#define FILE_NOT_EXIST -16
#define URL_CAPACITY_PROBLEME	503
#define URL_NOT_FOUND	404
#define CTRLFILE_NOT_OK	999
#define CTRLFILE_IS_CMP	998
#define URL_REGERR -99
#define URL_ACCERR -98
#define URL_SESSION_OPEN_ERR -97
#define URL_SESSION_CLOSE_ERR -96
#define URL_ACC_OUT_OF_TIME -95
#define SUFFIX_OPEN_ERROR -94
#define NO_NET_CONNECTION -93
#define SERVER_OPEN_ERR -92


#pragma pack(pop)
#endif	//_RC7A_DEFINITIES