////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RadioJet
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"
#include <direct.h>
#include <sys/utime.h>
#include <mmsystem.h>
#include <io.h>

#include "MWListFrqConverter.h"
#include "MWListFrqConverterDlg.h"
#include "Defs.h"


//#include "OwnTestRoutines.cpp"

char				myDIR[256];
class CMWListFrqConverterDlg *my_mainframe=NULL;	

///////////////////////////////////////////////////////////
////////////////////// get Tables, List and Strings ///////////////////
///////////////////////////////////////////////////////////

FrqListData		NewFrqData,FrqData;
FrqListData		BonitoFrqPool[12][6];
IsoList			myCountries,myLanguages; 
SortIndex		mySortedCountries,mySortedLanguages;
CStringArray	myRegionsList;
IsoBList		myITU;
SortIndex		mySortedITU;
CProgressCtrl	*myProg=NULL;
DWORD			timeout=60*CLOCKS_PER_SEC;
char			FrqConvDir[256];
int				checkBonitoList=1;
HWND			QuitWin=0;

time_t  WINAPI GetLastWriteTime(char *filename)
{
	WIN32_FILE_ATTRIBUTE_DATA fattr;

	//return FALSE is the same as file not exist;
	if(!GetFileAttributesEx(filename, GetFileExInfoStandard, &fattr))  return FALSE;
	CTime	tim(fattr.ftLastWriteTime);
	return tim.GetTime(); 
}

//kill the last spaces
int WINAPI KillspaceSL(char *buf)
{
	for(int i=(int)strlen(buf)-1; i>=0 ; i--)
		{
		if(buf[i]!=' ' && buf[i]!=13 && buf[i]!=10 && buf[i]!=9 && buf[i]!='/')
			{
			buf[i+1]=0; 
			break;
			}
		}
	return strlen(buf);
}

//kill the last spaces
int WINAPI Killspace(char *buf)
{
	for(int i=(int)strlen(buf)-1; i>=0 ; i--)
		{
		if(buf[i]!=' ' && buf[i]!=13 && buf[i]!=10 && buf[i]!=9)
			{
			buf[i+1]=0; break;
			}
		}
	return strlen(buf);
}

int WINAPI KillDoubleSpace(char *buf)
{
	Killspace(buf);
	int x,i;

	for(x=0,i=0; i<(int)strlen(buf); i++)
		{
		if(buf[i]==' ' && buf[i+1]==' ') continue;
		buf[x++]=buf[i]; 
		}
	buf[x]=0;
	return strlen(buf);
}

int WINAPI KillBothDir(char *buf)
{
	Killspace(buf);
	int x,i;

	for(x=0,i=0; i<(int)strlen(buf); i++)
		{
		if(!x && buf[i]==' ') continue;
		buf[x++]=buf[i]; 
		}
	buf[x]=0;
	return strlen(buf);
}

typedef struct
				{
				int		Region_nr;
				int		lon;
				int		lat;
				char	RegionName1[32];
				char	RegionName2[32];
				int		LinePntr;
				int		LineSize[4];
				int		LinePosLon[4][32];
				int		LinePosLat[4][32];
				}WMORGN;

typedef struct	{
				COORDIANTE	p[64];
				int			count;
				int			region;
				}WMO_REGION_POINTS;

typedef CArray<WMO_REGION_POINTS,WMO_REGION_POINTS&> RegPoints;

typedef struct
	{
	UINT	population;		//4:population/500
	UINT	item:24;		//8:24:source position = unsorted;
	UINT	RegionNr:4;		//8:28:the number of the region
	UINT	type:4;			//8:32:0=city 1=prefix; 3=Country/Region
	UINT	height:16;		//12:16:height in meter
	UINT	country:10;		//12:26:ISO-Number = index of the country list
	UINT	DoubleFlags:2;	//12:28:this flag indicates that the name is twice
	UINT	WorkFlags:4;	//12:32:for intern sort routines and so one....	
	}CITY;


typedef struct
	{
	UINT	LocSetID;		// 4:a uniqu ID = (today&0xFFFF)<<16; + ?-count
	short	lon,lat;		// 8:location coordinates
	short	cx,cy;			//12:witdh, height
 	char	name[32];		//44:(excl. ':') name of the City, normal <32 chars --> if included a prefix, then the prefix is splitted by ':'
	union
		{
		char prefix[12];
		CITY city;
		};
	}LOCATION;

typedef	CArray<LOCATION,LOCATION&> Location;

typedef struct
	{
	int				LocCluster[12][6];	//Seek Position in Location (p.ex. Cities.bin) map grid = 30 x 30 
	int				ClusterSize[12][6];
	}CITY_HDR;


WMORGN			WmoRegs[7]={0};
RegPoints		wmoRegions;
Location		Cities[12][6];
CITY_HDR		CityHeader;

void WINAPI LoadRegions() 
{
	FILE	*fi;
	char	buf[512];
	int		i,l,y,k;
	WMO_REGION_POINTS	wmoPoints;

	sprintf(buf,"%s\\Data\\WmoRegions.bin",myDIR);
	fi=fopen(buf,"rb");
	if(fi)
		{
		fread(&WmoRegs,sizeof(WMORGN),7,fi);
		fclose(fi);
		}

	for(i=0; i<7; i++)
		{
		l=WmoRegs[i].LinePntr+1;
		memset(&wmoPoints,0,sizeof(WMO_REGION_POINTS));

		for(y=0;y<l; y++)
			{
			wmoPoints.region=i+1;
			wmoPoints.count=0;
			for(k=0; k<WmoRegs[i].LineSize[y]; k++)
				{
				wmoPoints.p[wmoPoints.count].x=10800+WmoRegs[i].LinePosLon[y][k];
				wmoPoints.p[wmoPoints.count++].y=5400+WmoRegs[i].LinePosLat[y][k];
				}
			wmoPoints.p[wmoPoints.count].x=wmoPoints.p[0].x;
			wmoPoints.p[wmoPoints.count++].y=wmoPoints.p[0].y;
			}
		wmoRegions.Add(wmoPoints);
		}

	CSize s;
	sprintf(buf,"%s\\CHARTDATA\\CityMap.bin",myDIR);
	fi=fopen(buf,"rb");
	if(!fi) return;
	l=(_filelength(_fileno(fi))-sizeof(CITY_HDR))/sizeof(LOCATION);
	fread(&CityHeader,sizeof(CITY_HDR),1,fi);

	for(int lat=0;lat<6;lat++)
		{
		for(int lon=0;lon<12;lon++)
			{
			Cities[lon][lat].RemoveAll();
			Cities[lon][lat].SetSize(CityHeader.ClusterSize[lon][lat]);
			fseek(fi,CityHeader.LocCluster[lon][lat],SEEK_SET);
			fread(Cities[lon][lat].GetData(),sizeof(LOCATION),CityHeader.ClusterSize[lon][lat],fi);
			}
		}

	fclose(fi);
}

void WINAPI LoadBonitoFrqPool() 
{
	FILE		*fi;
	char		buf[512];
	int			i,j,pset,s=0,lat,lon,len;

	FRQLISTDAT	dat={0};

	for(lat=0;lat<6;lat++)
		{
		for(lon=0;lon<12;lon++)
			{
			BonitoFrqPool[lon][lat].RemoveAll();
			}
		}

	for(i=0; i<10; i++)
		{
		sprintf(buf,"%s\\Data\\FrqData%02X.dat",myDIR,i);
		fi=fopen(buf,"rb");
		if(!fi) continue;
		len=_filelength(_fileno(fi));
		len=len/sizeof(FRQLISTDAT); len--;
		fread(&dat,sizeof(FRQLISTDAT),1,fi); //read the Info Dummy
		for(j=0; j<len; j++)
			{
			fread(&dat,sizeof(FRQLISTDAT),1,fi); //read a data set
			if(dat.db.lon && dat.db.lat)
				{
				lon=(10800+dat.db.lon)/1800; 
				if(lon<0 || lon>11) continue;
				lat=(5400+dat.db.lat)/1800; 
				if(lat<0 || lat>5) continue;
				BonitoFrqPool[lon][lat].Add(dat);
				pset=(int)(double)((5.0/(double)len)*(double)j);
				myProg->SetPos(s+pset);
				}
			}
		fclose(fi);
		s+=5;
		}
}

#include <math.h>
#define RAD				(0.017453292519943295769236907684886)	//(PI / 180.)	
#define RA				6378.137				//Radius of the world
/*------------------------------------*
 * calulate distance between 2 Points *
 *------------------------------------*/
double WINAPI GetDistance(double xs, double ys, double xe, double ye)
{
	double	x1,x2,y1,y2,a,b;

	if(xs == xe && ys == ye) return(0.0);

	x1 =(xs / 60.0);
	y1 =(ys / 60.0);
	x2 =(xe / 60.0);
	y2 =(ye / 60.0);

	a= (x1-x2);
	b= (y1-y2);
	if (a<0.)a=-a;
	if (b<0.)b=-b;
	
	if(a<(180.) && b<(90.))
		{
		x1 *=RAD;
		y1 *=RAD;
		x2 *=RAD;
		y2 *=RAD;
		return acos(sin(x1)*sin(x2)+cos(x1)*cos(x2)*cos(y2-y1))*RA;
		}

	x1 *=RAD;
	y1 *=RAD;
	x2 *=RAD;
	y2 *=RAD;

	a= (x1-x2)*cos(y1);
	b= (y1-y2);
 	
	if (a<0.)a=-a;
	if (b<0.)b=-b;
	return(sqrt(a*a+b*b)*RA);
}

//I know, these are not my best effective routines 
//.... but I'm too lazy now

BOOL WINAPI FindInBonitoFrqPool(FRQLISTDAT &code) 
{
	int LonS=(10740+code.db.lon)/1800;
	int	LonE=(10860+code.db.lon)/1800;
	int LatS=(5340+code.db.lat)/1800;
	int	LatE=(5460+code.db.lat)/1800;
	int x,y,i;
	int la1=(code.db.lat+3)&0xFFFC;
	int lo1=(code.db.lon+3)&0xFFFC;

	
	if(!code.db.lon && !code.db.lat) return NULL;
	double xs=(double)code.db.lon;
	double ys=(double)code.db.lat;

	double dist,lastdist=9999999.;
	int lastx=-1,lasty=-1,lasti=-1;
	if(LatS<0) LatS=0;
	if(LatE>5) LatE=5;

	for(x=LonS; x<=LonE; x++)
		{
		if(x<0) continue;
		if(x>11) continue;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<BonitoFrqPool[x][y].GetSize(); i++)
				{
				
				if(code.db.frq!=BonitoFrqPool[x][y][i].db.frq) continue;
				if(((BonitoFrqPool[x][y][i].db.lon+3)&0xFFFC)==lo1 &&  ((BonitoFrqPool[x][y][i].db.lat+3)&0xFFFC)==la1)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)BonitoFrqPool[x][y][i].db.lon,(double)BonitoFrqPool[x][y][i].db.lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}
		}
	if(LonS<0) 
		{
		x=11;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<BonitoFrqPool[x][y].GetSize(); i++)
				{
				if(code.db.frq!=BonitoFrqPool[x][y][i].db.frq || code.db.country!=BonitoFrqPool[x][y][i].db.country) continue;
				if(code.db.country!=BonitoFrqPool[x][y][i].db.country) continue;
				if(((BonitoFrqPool[x][y][i].db.lon+3)&0xFFFC)==lo1 &&  ((BonitoFrqPool[x][y][i].db.lat+3)&0xFFFC)==la1)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)BonitoFrqPool[x][y][i].db.lon,(double)BonitoFrqPool[x][y][i].db.lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}

		}
	if(LonE>11) 
		{
		x=0;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<BonitoFrqPool[x][y].GetSize(); i++)
				{
				if(code.db.frq!=BonitoFrqPool[x][y][i].db.frq || code.db.country!=BonitoFrqPool[x][y][i].db.country) continue;

				if(((BonitoFrqPool[x][y][i].db.lon+3)&0xFFFC)==lo1 &&  ((BonitoFrqPool[x][y][i].db.lat+3)&0xFFFC)==la1)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)BonitoFrqPool[x][y][i].db.lon,(double)BonitoFrqPool[x][y][i].db.lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}
		}

	i=lasti;
	x=lastx;
	y=lasty;

	if(i>=0 && x>=0 && y>=0 && code.db.frq==BonitoFrqPool[x][y][i].db.frq && lastdist<5)	//only those who lie in the very near
		{
		if(strstr(code.db.name,BonitoFrqPool[x][y][i].db.name) || strstr(BonitoFrqPool[x][y][i].db.name,code.db.name))
			{
			goto setLonLat;
			}

		strncpy(code.db.location,BonitoFrqPool[x][y][i].db.location,23);
		code.db.location[23]=0;

		code.db.steps=BonitoFrqPool[x][y][i].db.steps;
		code.db.IFBandwidth=BonitoFrqPool[x][y][i].db.IFBandwidth;
		code.db.decoder=BonitoFrqPool[x][y][i].db.decoder;
		code.db.height=BonitoFrqPool[x][y][i].db.height;
		code.db.modulation=BonitoFrqPool[x][y][i].db.modulation;
		code.db.modulationtype=BonitoFrqPool[x][y][i].db.modulationtype;
		code.db.stationtype=BonitoFrqPool[x][y][i].db.stationtype;
		memcpy(&code.db.drm,&BonitoFrqPool[x][y][i].db.drm,sizeof(FRQ_DRM_SET));
		memcpy(&code.db.audio,&BonitoFrqPool[x][y][i].db.audio,sizeof(FRQ_AUDIO_SET));
		memcpy(&code.db.fax,&BonitoFrqPool[x][y][i].db.fax,sizeof(FRQ_FAX_SET));
		memcpy(&code.db.sstv,&BonitoFrqPool[x][y][i].db.sstv,sizeof(FRQ_SSTV_SET));
		memcpy(&code.db.rtty,&BonitoFrqPool[x][y][i].db.rtty,sizeof(FRQ_RTTY_SET));
		memcpy(&code.db.cw,&BonitoFrqPool[x][y][i].db.cw,sizeof(FRQ_CW_SET));
		memcpy(&code.db.time,&BonitoFrqPool[x][y][i].db.time,sizeof(FRQ_TIME_SET));
		//memcpy(&code.db.schSet,&BonitoFrqPool[x][y][i].db.schSet,sizeof(SCH_TIME_SET));
		memcpy(&code.dh,&BonitoFrqPool[x][y][i].dh,sizeof(FRQLISTHEAD));
		return 2;
		}
	return 0;


setLonLat:
	memcpy(&code,&BonitoFrqPool[x][y][i],sizeof(FRQLISTSET));
	return 1;

}

void WINAPI FindLocation(FRQLISTDAT &code)
{
	int LonS=(10740+code.db.lon)/1800;
	int	LonE=(10860+code.db.lon)/1800;
	int LatS=(5340+code.db.lat)/1800;
	int	LatE=(5460+code.db.lat)/1800;
	int x,y,i;
	
	double xs=(double)code.db.lon;
	double ys=(double)code.db.lat;

	double dist,lastdist=9999999.;
	int lastx=-1,lasty=-1,lasti=-1;
	if(LatS<0) LatS=0;
	if(LatE>5) LatE=5;

	for(x=LonS; x<=LonE; x++)
		{
		if(x<0) continue;
		if(x>11) continue;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<Cities[x][y].GetSize(); i++)
				{
				if(Cities[x][y][i].lon==code.db.lon && Cities[x][y][i].lat==code.db.lat)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)Cities[x][y][i].lon,(double)Cities[x][y][i].lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}
		}
	if(LonS<0) 
		{
		x=11;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<Cities[x][y].GetSize(); i++)
				{
				if(Cities[x][y][i].lon==code.db.lon && Cities[x][y][i].lat==code.db.lat)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)Cities[x][y][i].lon,(double)Cities[x][y][i].lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}

		}
	if(LonE>11) 
		{
		x=0;
		for(y=LatS; y<=LatE; y++)
			{
			for(i=0; i<Cities[x][y].GetSize(); i++)
				{
				if(Cities[x][y][i].lon==code.db.lon && Cities[x][y][i].lat==code.db.lat)
					{
					goto setLonLat;
					}
				dist=GetDistance(xs,ys,(double)Cities[x][y][i].lon,(double)Cities[x][y][i].lat);
				if(dist<0.) dist=-dist;
				if(dist<lastdist) 
					{
					lastdist=dist;
					lasti=i;
					lastx=x;
					lasty=y;
					}
				}
			}
		}

	i=lasti;
	x=lastx;
	y=lasty;

	if(i>=0 && x>=0 && y>=0 && lastdist<30)
		{
setLonLat:
		strncpy(code.db.location,Cities[x][y][i].name,23);
		code.db.location[23]=0;
		}

}


inline int isLeft(COORDIANTE *P0, COORDIANTE *P1, COORDIANTE P2 )
{
    return ( (P1->x - P0->x) * (P2.y - P0->y) - (P2.x - P0->x) * (P1->y - P0->y) );
}

BOOL  WINAPI IsPointInPolygon(COORDIANTE *rgpts, int wnumpts, COORDIANTE ptTest)
{
    int    i,wn = 0;    // the winding number counter
	COORDIANTE  *ppt ;

    // line through all edges of the polygon
	for (i = 0, ppt = rgpts ; i < wnumpts-1 ; i++, ppt++)
		{
        if (ppt->y <= ptTest.y) 
			{	// start y <= pt->y
            if ((ppt+1)->y > ptTest.y)      // an upward crossing
              if (isLeft(ppt, ppt+1, ptTest) > 0)  // P left of edge
                    ++wn;					// have a valid up intersect
			}
        else 
			{	// start y > P.y (no test needed)
			if ((ppt+1)->y <= ptTest.y)     // a downward crossing
              if (isLeft(ppt, ppt+1, ptTest) < 0)  // P right of edge
                    --wn;				// have a valid down intersect
			}
		}
    if (wn==0) return false;
	return true;
}

int WINAPI FindRegion(int x, int y) 
{
	int i;
	COORDIANTE	ptTest;

	ptTest.x=10800+(short)x;
	ptTest.y=5400+(short)y;
	for(i=0; i<wmoRegions.GetSize(); i++)
		{
		if(IsPointInPolygon(wmoRegions[i].p,wmoRegions[i].count,ptTest)) 
			{
			return wmoRegions[i].region; 	
			}
		}
	return 0;
}


LNG_List		myLNG;
SortIndex		mySortedLongLNG,mySortedShortLNG;


void WINAPI	Get_LNG() 
{
	FILE		*fi=0;
	int			i;
	char		buf[256];
	LNGCODE		code;

	myLNG.RemoveAll(); 

	//01234567890123456789
	//---,  ,   ,0   ,Undefined
	//abp,  ,   ,13  ,Abenlen Ayta
	mySortedShortLNG.SetSize(512);
	for(i=0; i<512; i++) mySortedShortLNG[i]=0;

	sprintf(buf,"%s\\InputList\\LNG-List.txt",FrqConvDir);
	fi=fopen(buf,"r");
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			memset(&code,0,sizeof(LNGCODE));
			code.A3[0]=buf[0]; code.A3[1]=buf[1]; code.A3[2]=buf[2]; strlwr(code.A3); 
			code.A2[0]=buf[4]; code.A2[1]=buf[5]; strlwr(code.A2);
			buf[10]=0; code.shortNumber=atoi(&buf[7])&511;
			buf[15]=0; code.longNumber=atoi(&buf[11]);
			buf[65]=0; strcpy(code.Name,&buf[16]);
			Killspace(code.Name);
			myLNG.Add(code);
			if(code.shortNumber) mySortedShortLNG[code.shortNumber]=code.longNumber; 
			}
		fclose(fi);
		}
	else return;

	mySortedLongLNG.SetSize(myLNG.GetSize());
	for(i=0; i<myLNG.GetSize(); i++) mySortedLongLNG[i]=i;
}


void WINAPI	Get_ITU() 
{
	FILE		*fi=0;
	char		buf[256];
	ISOCODE_B	code;

	myITU.RemoveAll(); 

	//012345678901234567890123456789012345678901234567890123456789
	//---,0 ,Undefined
	//AFG Afghanistan                                        //
	mySortedITU.SetSize(256);
	for(int i=0; i<256; i++) mySortedITU[i]=0;

	sprintf(buf,"%s\\InputList\\ADM-List.txt",FrqConvDir);
	fi=fopen(buf,"r");
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			memset(&code,0,sizeof(ISOCODE_B));
			code.A3[0]=buf[0]; code.A3[1]=buf[1]; code.A3[2]=buf[2]; strlwr(code.A3); 
			buf[7]=0; code.Number=atoi(&buf[4])&255;
			buf[54]=0; strcpy(code.Name,&buf[8]);
			Killspace(code.Name);
			myITU.Add(code);
			mySortedITU[code.Number]=code.Number; 
			}
		fclose(fi);
		}
	else return;
}


void WINAPI	GetIsoList(char *file, int max, IsoList &List,SortIndex &Idx) 
{

//realloc

	FILE		*fi=0;
	int			set=0;
	int			x,i,s,nr=0;
	char		buf[256];
	SortIndex	AlfaSortList;

	List.RemoveAll();
	List.SetSize(max);
	memset(List.GetData(),0,sizeof(ISOCODE_A)*max);

	//01234567890
	//AFG,AF,4  ,AFGHANISTAN
	//deu,de,143,German
	fi=fopen(file,"r");	
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			buf[3]=0;
			buf[6]=0;
			buf[10]=0;
			buf[61]=0; //maximum = 50 chars
			nr=atoi(&buf[7]);
			if(nr<0 || nr>=max) nr=0;
			strlwr(buf);
			strcpy(List[nr].A3,buf);
			strlwr(&buf[4]);
			strcpy(List[nr].A2,&buf[4]);
			List[nr].Number=nr;	
			strcpy(List[nr].Name,&buf[11]);
			Killspace(List[nr].Name);
			}
		fclose(fi);
		}
	else return;


	AlfaSortList.SetSize(max);
	for(i=0; i<max; i++) AlfaSortList[i]=i;
	s=1;
	while(s)
		{
		for(i=2,s=0; i<max; i++)
			{
			if(strcmp(List[AlfaSortList[i-1]].Name,List[AlfaSortList[i]].Name)>0)
				{
				s=AlfaSortList[i-1];
				AlfaSortList[i-1]=AlfaSortList[i];
				AlfaSortList[i]=s;
				s=1;
				}
			}
		}

	for(x=i=0; i<max; i++) 
		{
		List[AlfaSortList[i]].sort=i;
		List[AlfaSortList[i]].item=-1;
		if(List[AlfaSortList[i]].Name[0])
			{
			List[AlfaSortList[i]].item=x++;
			List[AlfaSortList[i]].Number=AlfaSortList[i];
			Idx.Add(AlfaSortList[i]);
			}
		}
}

void WINAPI	GetStringList(char *file, CStringArray &List) 
{
	FILE		*fi=0;
	char		buf[256];
	CString		str;

	List.RemoveAll();

	fi=fopen(file,"r");	
	if(fi) 
		{
		while(!feof(fi))
			{
			fgets(buf,255,fi);
			if(buf[0]=='/') continue; 
			Killspace(buf);
			str=buf;
			List.Add(str);
			}
		fclose(fi);
		}
}

int WINAPI	FindOfCountries(char *country) 
{
	int i,j;
	if(country[0]==' ' && country[1]==' ') return 0;
	if(country[0]=='b' && country[1]==' ') return 76;
	if(country[0]=='f' && country[1]==' ') return 250;
	if(country[0]=='d' && country[1]==' ') return 276;
	if(country[0]=='i' && country[1]==' ') return 380;
	if(country[0]=='j' && country[1]==' ') return 392;
	if(country[0]=='e' && country[1]==' ') return 724;
	if(country[0]=='s' && country[1]==' ') return 752;
	if(country[0]=='g' && country[1]==' ') return 826;
	if(country[0]=='t' && country[1]=='k' && country[2]=='s') return 156; //china
	if(country[0]=='t' && country[1]=='i' && country[2]=='b') return 156; //china
	if(country[0]=='a' && country[1]=='r' && country[2]=='s') return 682; //saudi arabia
	if(country[0]=='m' && country[1]=='r' && country[2]=='a') return 840; //tinian island (USA)
	if(country[0]=='b' && country[1]=='i' && country[2]=='o') return 826; //Diego Garcia (UK) british indian ocean
	if(country[0]=='a' && country[1]=='s' && country[2]=='c') return 826; //Ascension (UK) 
	if(country[0]=='a' && country[1]=='l' && country[2]=='s') return 840; //Anchor Point (USA) alaska
	if(country[0]=='s' && country[1]=='r' && country[2]=='b') return 891; //Serbia
	if(country[0]=='r' && country[1]=='u' && country[2]=='v') return 643; //Russia
	if(country[0]=='s' && country[1]=='u' && country[2]=='i') return 756; //Switzerland
	if(country[0]=='k' && country[1]=='r' && country[2]=='e') return 408; //north Korea
	if(country[0]=='c' && country[1]=='v' && country[2]=='a') return 336; //Vatican


	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(!strcmp(country,myCountries[mySortedCountries[i]].A3))
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}

	j=-1;
	for(i=0; i<mySortedITU.GetSize(); i++)
		{
		if(!strcmp(country,myITU[mySortedITU[i]].A3))
			{
			j=mySortedITU[i];
			break;
			}
		}

	if(j!=-1)
	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(!strcmp(myITU[j].Name,myCountries[mySortedCountries[i]].Name))
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}

	return 0;
}

int WINAPI	GetIndexOfCountryA2(char *A2) 
{
	int		i;

	for(i=0; i<mySortedCountries.GetSize(); i++)
		{
		if(myCountries[mySortedCountries[i]].A2[0]==A2[0] && myCountries[mySortedCountries[i]].A2[1]==A2[1])
			{
			return myCountries[mySortedCountries[i]].Number;
			}
		}
	return 0;
}

int WINAPI	FindIndexOfLanguageA2(char *A2,char *buf) 
{
	int		i;
	for(i=0; i<mySortedLanguages.GetSize(); i++)
		{
		if(myLanguages[mySortedLanguages[i]].A2[0]==A2[0] 
			&& myLanguages[mySortedLanguages[i]].A2[1]==A2[1])
			{
			strncpy(buf,myLanguages[mySortedLanguages[i]].Name,24);
			buf[24]=0;
			return myLanguages[mySortedLanguages[i]].Number;
			
			}
		}
	return 0;
}

 
int WINAPI	find_Language(char *str)
{
	int	i;

	char cmp[256],buf[256];
	for(i=0; i<(int)strlen(str); i++)
		{
		if(!isalpha((int)str[i])) break;
		buf[i]=str[i];
		}
	buf[i]=0;
	_strupr(buf);

	for(i=0; i<myLNG.GetSize(); i++)
		{
		strcpy(cmp,myLNG[i].Name);
		_strupr(cmp); 
		if(!strcmp(buf,cmp)) return i;
		}
	return -1;
}

int WINAPI	FindLanguage(char *language) 
{
	if(language[strlen(language)-1]==',') language[strlen(language)-1]=0;
	for(int i=0; i<mySortedLanguages.GetSize(); i++)
		{
		if(!strcmp(language,myLanguages[mySortedLanguages[i]].Name))
			{
			return myLanguages[mySortedLanguages[i]].Number;
			}
		}
	return 0;
}

BOOL WINAPI	GetSingleChar(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	char *find;
	find=strstr(code.db.name,oldname);
	if(find)
		{
		find--;
		if(find[0]==' ') return FALSE;
		}

	CString str;
	str=code.db.name;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.name,str,31);
		code.db.name[31]=0;
		return TRUE;
		}
	return FALSE;
}

BOOL WINAPI	GetName(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	CString str;
	str=code.db.name;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.name,str,31);
		code.db.name[31]=0;
		return TRUE;
		}
	return FALSE;
}

BOOL WINAPI	GetLang(FRQLISTDAT	&code, char *oldname, char *newname) 
{
	CString str;
	str=code.db.language;
	if(str.Replace(oldname,newname))
		{
		if(str.GetLength()>31) return FALSE;
		strncpy(code.db.language,str,31);
		code.db.language[31]=0;
		return TRUE;
		}
	return FALSE;
}

void WINAPI	SplitCallStr(char *tar1, char *tar2, char *buf,int len) 
{
	int		i,x,fi=0,kommata=-1;
	char	tmp[16];

	for(i=0; i<14; i++)
		{
		tmp[i]=buf[i];
		if(buf[i]>='0' && buf[i]<='9') fi=1;

		if(buf[i]==',') 
			{
			kommata=i;
			break;
			}
		if(buf[i]==' ')
			{
			if(buf[i+1]==',')
				{
				kommata=i;
				break;
				}

			if(buf[i+1]<'0' || buf[i+1]>'9') 
				{
				kommata=-1;
				break;
				}
			}
		
		}
	tmp[i]=0;
	if(fi && kommata<1 && i<9)
		{
		for(i=0; i<8; i++)
			{
			tmp[i]=buf[i];
			if(buf[i]==' ') 
				{
				kommata=i;
				break;
				}
			}
		tmp[i]=0;
		}

	if(kommata<1)
		{
		for(i=0; i<31; i++)
			{
			tar1[i]=buf[i];
			}
		tar1[i]=0;
		return;
		}

	if(strstr(tmp,"China"))
		{
		i=i;
		}
	strcpy(tar2,tmp);
	if(buf[kommata]==','||buf[kommata]==' ') kommata++;
	if(buf[kommata]==','||buf[kommata]==' ') kommata++;
	if(buf[kommata]==','||buf[kommata]==' ') kommata++;

	for(x=0,i=kommata; i<len; i++,x++)
		{
		tar1[x]=buf[i];
		if(x==31) break;
		}
	tar1[31]=0;
}

void WINAPI	GetStr(char *tar, char *buf,int len) 
{
	for(int i=0; i<len; i++)
		{
		tar[i]=buf[i];
		}
	tar[i]=0;
}

int WINAPI	GetInt(char *buf,int len) 
{
	char tar[128];
	for(int i=0; i<len; i++)
		{
		tar[i]=buf[i];
		}
	tar[i]=0;
	return atoi(tar);
}

float WINAPI GetFloat(char *buf,int len) 
{
	char tar[128];
	for(int i=0; i<len; i++)
		{
		tar[i]=buf[i];
		if(tar[i]==',') tar[i]='.';
		}
	tar[i]=0;
	return (float)atof(tar);
}



void WINAPI	Get_MWList() 
{
//fffffff (c) www.mwlist.org ________________________________________________________________________________________________________________
//17,2   0800-10009999999S  SAQ, Grimeton                                       temporary, special transmissio57.105556 12.390278  86011   
//fffffffutc_-utc_1234567itustation_________________________________lakw________remarks_______________________latidec___longidec___uid_______:
//16,4   0400-0600       NORJXN, Gildeskl/Novik                      45.000000 FSK, 200 Bd                   66.982778 13.873056  86009     +
//860,0                  USAKWPC, Muscatine, IA                       0.250000                                41.442778 -91.075833 39744  
//-------+---++---+------+------------------------------------------+-+---------+-----------------------------+---------+----------+---------+----------------------------------------
//012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
//;---------1---------2---------3---------4---------5---------6---------7---------8---------9---------10--------11--------12--------13--------14--------15--------16--------17---------

	FILE		*fi=0;
	char		tmp[256],buf[256],day;
	FRQLISTDAT	code;
	int			max,pin=0,pset,i,x,len,tstop;
	CString		str;
	
	x=sizeof(FRQLISTSET);
	NewFrqData.RemoveAll(); 

	sprintf(buf,"%s\\InputList\\MWList.txt",FrqConvDir);
	fi=fopen(buf,"r");

	if(fi) 
		{
		myProg->SetPos(100);

		max=(_filelength(_fileno(fi)));

		while(!feof(fi))
			{
			fgets(tmp,255,fi); strcpy(buf,tmp);
			len=strlen(buf); 
			pin+=len;
			pset=(int)(double)((100.0/(double)max)*(double)pin);
			myProg->SetPos(100+pset);
			
			len--;
			buf[len]=0;
			if(buf[0]=='f') continue;
			
	
			memset(&code,0,sizeof(FRQLISTDAT));
	
			code.db.fax.modul		=576;
			code.db.fax.speed		=120;		 
			code.db.fax.centerfrq	=1900;	 
			code.db.fax.shift		=800;	
			code.db.fax.filterwidth	=1200;
			code.db.fax.burst1		=1040;
			code.db.fax.burst2		=250;
			//code.db.fax.hmirror=0;	 
			//code.db.fax.vmirror=0;	 
			//code.db.fax.amfm=0;		 
			code.db.fax.filteronoff	=1;
			code.db.fax.filtermode	=2; 
			code.db.fax.syncwidth	=5;	 
			//code.db.fax.invertsync=0;
			//code.db.fax.SatID		=0;

			code.db.sstv.mode		=44;	//	SSTV_MODE_M1	
			code.db.sstv.synfrq		=1200;
			code.db.sstv.filterwidth=160;	
			code.db.sstv.filtertype	=0x04; //AIO_HANN;	
			code.db.sstv.filter_onoff=1;

			code.db.rtty.baud		=50;
			code.db.rtty.mark		=1275;
			code.db.rtty.space		=1700;
			code.db.rtty.stopbits	=1;
			//code.db.rtty.polarity	=0;
			//code.db.rtty.mode		=0=RTTY_MODE_BAUDOT;
			//code.db.rtty.RegLetter =0;

			code.db.cw.center		=1000;		 
			code.db.cw.mark			=1000;		 
			code.db.cw.width		=50;
			code.db.cw.afc			=1;
			code.db.cw.mode			=0;

			code.db.modulation=RADIO_MODE____; //??
			code.db.modulationtype=25; //=??
			code.db.stationtype=16; //=??
			code.db.steps=1000;
			code.db.decoder=DEC_AUDIO;
			code.db.IFBandwidth=9000;
	
			code.db.frq=GetInt(buf,7)*1000;
			if(code.db.frq<1000) continue;
			if(code.db.frq==11770000) 
				{
				i=i;
				}
			x=FRQ_DAYS_SU;
			for(i=0; i<7; i++)
				{
				day=0x31+i;
				if(buf[16+i]==day) code.db.schSet.sch_time_Days|=x;
				x>>=1;
				}
			code.db.schSet.sch_time_Start=GetInt(&buf[7],2)*60+GetInt(&buf[9],2);
			code.db.schSet.sch_time_Stop=GetInt(&buf[12],2)*60+GetInt(&buf[14],2);
			if(!code.db.schSet.sch_time_Start && !code.db.schSet.sch_time_Stop) 
				{
				code.db.schSet.sch_time_Stop=1440; //0000-2400
				code.db.schSet.sch_time_Days=FRQ_DAYS_ALL;
				}
			else if(code.db.schSet.sch_time_Start || code.db.schSet.sch_time_Stop && !code.db.schSet.sch_time_Days)
				{
				code.db.schSet.sch_time_Days=FRQ_DAYS_ALL;
				}	

			GetStr(code.db.ITU, &buf[23],3); 
			strlwr(code.db.ITU);
			code.db.country=FindOfCountries(code.db.ITU); 
			KillBothDir(code.db.ITU);
			strupr(code.db.ITU);

			SplitCallStr(code.db.name, code.db.call,&buf[26],40); 
			KillBothDir(code.db.name);
			KillBothDir(code.db.call);

			GetStr(tmp,&buf[66],2);
			x=0; if(tmp[0]!=32 && tmp[1]!=32) 
				{
				strlwr(tmp);
				x=FindIndexOfLanguageA2(tmp,code.db.language);
				if(x)
					{
					code.db.modulation=RADIO_MODE_AM;
					code.db.modulationtype=11;
					code.db.stationtype=12; 
					}
				}
			code.db.extraInfo.extraFlag=0x99FF;
			code.db.extraInfo.langNumber=x;
	
			code.db.PWR=(USHORT)(GetFloat(&buf[68],10)*100.f);
			GetStr(code.db.Commentary,&buf[78],30);
			KillBothDir(code.db.Commentary);
		
			if((code.db.Commentary[0]=='F' && code.db.Commentary[1]=='S' && code.db.Commentary[2]=='K')
			|| (code.db.Commentary[0]=='M' && code.db.Commentary[1]=='S' && code.db.Commentary[2]=='K')
			|| (code.db.Commentary[0]=='F' && code.db.Commentary[1]=='1' && code.db.Commentary[2]=='B')
			|| (code.db.Commentary[2]=='/' && code.db.Commentary[3]=='M' && code.db.Commentary[4]=='S' && code.db.Commentary[5]=='K')
			|| (code.db.Commentary[0]=='A' && code.db.Commentary[1]=='S' && code.db.Commentary[2]=='C' && code.db.Commentary[3]=='I'))
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=12288;  //RTTY BAUDOT
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				}
			else if(code.db.Commentary[0]=='C' && code.db.Commentary[1]=='W' && code.db.Commentary[2]==' ')
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=14336;  //CW
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				code.db.stationtype=7;	//HM    HAM-Beacon, automatic Amateur Radio Station"
				}
			else if(code.db.Commentary[0]=='P' && code.db.Commentary[1]=='S' && code.db.Commentary[2]=='K' && code.db.Commentary[3]==' ')
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=12545;  //PSK
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				code.db.stationtype=7;	//HM    HAM-Beacon, automatic Amateur Radio Station"
				}
			else if((code.db.Commentary[0]=='L' ||  code.db.Commentary[0]=='U') && code.db.Commentary[1]>='0' && code.db.Commentary[1]<='9')
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=14338;  //CW Non-Directional-Beacon (NDB)"); break;
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				code.db.stationtype=6;	//NB    NDB, Beacon, automatic Station"
				}
			else if(strstr(code.db.Commentary,"time signal") || strstr(code.db.Commentary,"Time signal"))
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=15360;  ///Times      TIME-Signal 
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				code.db.stationtype=13;	//13=SS   Time-Sinal or Norm Frequency, automatic Station
				}
			else if(strstr(code.db.Commentary,"NAVTEX"))
				{
				code.db.steps=100;
				code.db.IFBandwidth=2000;
				code.db.decoder=12306;  //Sitor-B (Navtext)
				code.db.modulationtype=18; //MODE_USB
				code.db.modulation=MODE_USB;
				code.db.stationtype=14;	//XX    NAVAREA Station 
				code.db.rtty.baud		=100;
				code.db.rtty.mark		=1275;
				code.db.rtty.space		=1445;
				code.db.rtty.stopbits	=1;
				code.db.rtty.polarity	=1; //revers
				code.db.rtty.mode		=2; //RTTY_MODE_SITOR;
				//code.db.rtty.RegLetter =0;
				}
			else if(strstr(code.db.Commentary,"DRM"))
				{
				code.db.modulation=RADIO_MODE_DRM;
				code.db.IFBandwidth=12000;
				code.db.modulationtype=24;
				code.db.drm.CodecTypeIdx=1;
				code.db.drm.DataAudioTypeIdx=1;
				code.db.drm.LanguageIdx=FindLanguage(code.db.language);
				code.db.drm.CountryIdx=code.db.country;
				code.WorkFlag=FRQ_DRMSET;
				}
			code.db.lat=(short)(GetFloat(&buf[108],10)*-60.f);
			code.db.lon=(short)(GetFloat(&buf[118],11)*60.f);
			if(code.db.lat && code.db.lon) code.db.RegionNr=FindRegion(code.db.lon,code.db.lat); 	

			if(code.db.schSet.sch_time_Stop<code.db.schSet.sch_time_Start) 
				{
				tstop=code.db.schSet.sch_time_Stop;
				code.db.schSet.sch_time_Stop=1440;
				NewFrqData.Add(code);
				code.db.schSet.sch_time_Stop=tstop;
				code.db.schSet.sch_time_Start=0;
				}

			x=FindInBonitoFrqPool(code); //x==0 then not found, x==1 the found and equal x==2 found in then near and filled 
			if(!x) FindLocation(code);
			if(x!=1 || !checkBonitoList) 
				{
				NewFrqData.Add(code);
				}
			}
		fclose(fi);
		}
	else return;
}

int WINAPI cmpNames(char *name1,char *name2)
{
	char buf1[256];
	char buf2[256];

	strcpy(buf1,name1);
	strcpy(buf2,name2);

	_strupr(buf1);  _strupr(buf2);
	Killspace(buf1); Killspace(buf2);

	return strcmp(buf1,buf2);
}

int WINAPI	CompareItems(int d1, int d2) 
{
	int	ret=1;

	if(FrqData[d2].db.frq>NewFrqData[d1].db.frq) return -1;		//the new is <<<<
	else
		{
		if(NewFrqData[d1].db.frq!=FrqData[d2].db.frq) return 1;
	
		// the frq is equal
		ret=cmpNames(NewFrqData[d1].db.name,FrqData[d2].db.name);
		if(ret) return ret;
		
		// also the name is equal, then compare the start time

		if(FrqData[d2].db.schSet.sch_time_Days>NewFrqData[d1].db.schSet.sch_time_Days) return -1; 
		if(FrqData[d2].db.schSet.sch_time_Days!=NewFrqData[d1].db.schSet.sch_time_Days) return 1; 

		if(FrqData[d2].db.schSet.sch_time_Start>NewFrqData[d1].db.schSet.sch_time_Start) return -1; //the new is <<<<
		/*if(FrqData[d2].db.schSet.sch_time_Start<NewFrqData[d1].db.schSet.sch_time_Start) return 1; 
		ret=cmpNames(NewFrqData[d1].db.call,FrqData[d2].db.call);
		if(ret) return ret;*/
		}
	return ret;	
}

int WINAPI AddFrq(int i)
{
	int		v,end,top=0,bot=0,mid,oldtop=-1,oldbot=-1;

	end=FrqData.GetSize();
	if(!end) {FrqData.Add(NewFrqData[i]); return end;}

	bot=end-1;

	v=CompareItems(i,bot);
	if(v==0) goto set;
	if(v>0)	{FrqData.Add(NewFrqData[i]); return end;}
		
	while(top!=bot)
		{
		mid = ((top+bot)>>1);
		if(oldtop==top && oldbot==bot) break;
		oldtop=top; oldbot=bot;
		v=CompareItems(i,mid);
		if(v==0) {bot=mid; goto set;}
		if(v<0)	//check the uppers bank
			{
			bot=mid; continue;
			}
		//check the lowers bank 
		top=mid; 
		}
set:
	if(v) FrqData.InsertAt(bot,NewFrqData[i]);
	return bot;
}

void WINAPI	GetTables() 
{
	char		buf[256];
	sprintf(buf,"%s\\Data\\LanguageList.txt",myDIR);
	GetIsoList(buf,500,myLanguages,mySortedLanguages);

	sprintf(buf,"%s\\Data\\CountryList.txt",myDIR);
	GetIsoList(buf,1000,myCountries,mySortedCountries);

	sprintf(buf,"%s\\Data\\RegionsList.txt",myDIR);
	GetStringList(buf,myRegionsList);

	LoadRegions();

	Get_LNG();
	Get_ITU();
	Get_MWList();

}

void WINAPI	MergeFrqList() 
{
	char	buf[256];
//	FILE	*fi;
	FILE	*fo;
	int		i,max=0;
	int		dNew=0;
	int		dOld=0;
	time_t	today=time(0);
	UINT	ID=(today&0xFFFF)<<16;
	FRQLISTDAT		myHeadDummy={0};
	CTime	tim(today);

	myHeadDummy.dh.FrqBase=13;		//Bonito ID FrqData0D 
	myHeadDummy.db.FrqSetDate=today;
	myHeadDummy.db.FrqUserID=0x4C4F5245;	//LORE (Lorenz)
	sprintf(myHeadDummy.db.Commentary,"FrqData0D %s MW List Source = http://www.mwlist.org",tim.Format("%d.%b.%Y"));
	strcpy(myHeadDummy.db.name,"FrqData0D the MWList (www.mwlist.org)");
	FrqData.RemoveAll();

	for(i=0; i<NewFrqData.GetSize(); i++) AddFrq(i);
	sprintf(buf,"%s\\Data\\FrqData0D.bin",myDIR);
	fo=fopen(buf,"wb");
	fwrite(&myHeadDummy,sizeof(FRQLISTDAT),1,fo); //write the old Header Dummy
	for(i=0; i<FrqData.GetSize(); i++)
		{
		if(i)
			{
			if(FrqData[i].db.frq==FrqData[i-1].db.frq 
			&& !memcmp(&FrqData[i].db.schSet,&FrqData[i-1].db.schSet,sizeof(SCH_TIME_SET)) 
			&& !strcmp(FrqData[i].db.name,FrqData[i-1].db.name) 
			&& !strcmp(FrqData[i].db.language,FrqData[i-1].db.language) 
			&& !strcmp(FrqData[i].db.location,FrqData[i-1].db.location)) continue;
			}

		if(i&1) ID+=3;
		else ID+=2;

		FrqData[i].dh.FrqBase=13;		//Bonito ID FrqData0D
		FrqData[i].dh.show=1;	
		FrqData[i].db.FrqSetDate=today;
		FrqData[i].db.FrqSetID=ID;
		FrqData[i].db.FrqUserID=0x4C4F5245; //LORE (Lorenz)
		fwrite(&FrqData[i],1,sizeof(FRQLISTDAT),fo);
		}
	fclose(fo);
}

BOOL WINAPI getRegString(HKEY key, char *KeyName, char *ValName, char *Default, char* DatBuf)
{
	HKEY	hKey;
	long	retCode;
	DWORD	dat_sodb=255,val_type=REG_SZ;

	DatBuf[0]=0;

	retCode=RegOpenKeyEx(key,KeyName,0,KEY_READ,&hKey);
	if(!retCode)
		{
		retCode=RegQueryValueEx(
							hKey,				// handle to key to query
							ValName,			// address of name of value to query
							NULL,				// reserved
							&val_type,			// address of buffer for value type
							(BYTE*)DatBuf,		// address of data buffer
							&dat_sodb			// address of data buffer size
							);
  		RegCloseKey (hKey); 
		}
	if(retCode && Default) strcpy(DatBuf,Default);
	return(retCode);
}

BOOL WINAPI getBothRegistry(char *ValName, char *Default, char* DatBuf)
{
	BOOL ret=getRegString(HKEY_CURRENT_USER,"Software\\Bonito\\RadioJet 1.0",ValName,Default,DatBuf);
	if(ret)	ret=getRegString(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\Bonito RadioJet 1.0",ValName,Default,DatBuf);
	return ret;
}

void WINAPI GetRadioJetDirectory()
{
	char buf[256];
	buf[0]=0;

	_getcwd(myDIR,255);
	getBothRegistry("AccessDir",myDIR,myDIR);
}

#include "Wininet.h"

// Flags for InternetGetConnectedState and Ex
//#define INTERNET_CONNECTION_MODEM           0x01	Local system uses a modem to connect to the Internet
//#define INTERNET_CONNECTION_LAN             0x02	Local system uses a local area network to connect to the Internet.
//#define INTERNET_CONNECTION_PROXY           0x04	Local system uses a proxy server to connect to the Internet.
//#define INTERNET_CONNECTION_MODEM_BUSY      0x08  /* no longer used */
//#define INTERNET_RAS_INSTALLED              0x10	Local system has RAS installed.
#define INTERNET_CONNECTION_OFFLINE         0x20	//Local system is in offline mode.
//#define INTERNET_CONNECTION_CONFIGURED      0x40  Local system has a valid connection to the Internet,
   											     // but it might or might not be currently connected.

BOOL WINAPI GetInternetConnectedState()
{
	ULONG	lpdwFlags;
	if(!(InternetGetConnectedState(&lpdwFlags,NULL))) return FALSE; 
	if(!(lpdwFlags & INTERNET_CONNECTION_OFFLINE)) return FALSE;
 return TRUE;	
}

DWORD	my_Connect=0;
void WINAPI ConnectOn()
{
	if(my_Connect) return;
	if(!GetInternetConnectedState()) 
		{
		//InternetAutodial(INTERNET_AUTODIAL_FORCE_UNATTENDED,my_mainframe->m_hWnd);
		InternetAutodial(INTERNET_AUTODIAL_FORCE_UNATTENDED,((ULONG)my_mainframe->m_hWnd));
		my_Connect=1;
		}
}

void WINAPI ConnectOff()
{
}

void WINAPI CloseConnect()
{
	if(my_Connect)
		{
		InternetAutodialHangup(NULL);
		my_Connect=NULL;
		}
}

BOOL WINAPI WriteText(char *text)
{
	my_mainframe->m_errorText=text;
	my_mainframe->UpdateData(FALSE);
	my_mainframe->erStatus.RedrawWindow();
	return NULL;
}

char ErrorMessageBuffer[256]; 
void WINAPI	ErrorMessages(char *buf,int flag)
{	
	char	tmp[512];

	if(flag) sprintf(tmp,"%s\n",buf);
	else strcpy (tmp,buf);
	WriteText(tmp);

} 

void WINAPI MakeDir(char *filename) 
{
	int		i,x;
	char	dir[512];

	dir[0]=0;
	for(i=0,x=0; i<(int)strlen(filename); i++)
		{
		if(filename[i]!='\\') {dir[x++]=filename[i]; dir[x]=0;}
		else
			{
			_mkdir(dir);
			dir[x++]=filename[i]; dir[x]=0;
			}
		}
}

