
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RadioJet
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "GlobalTools.h"

OldFrqListData	mOldData;
FrqListData		mNewData;

//converte the old RadioCom Frq-Data to the new Format
//also transfer the coordinates and schedule info
void WINAPI ConvertOldToNew()
{
	FILE			*fi;
	char			filename[256];
	int				i,max,deco;
	time_t			today=time(0);
	UINT			ID=(today&0xFFFF)<<16;
	FRQLISTDAT		myHeadDummy={0};
	O_FRQLISTDAT	olddat={0};
	FRQLISTDAT		newdat={0};
	CTime			tim(today);

	myHeadDummy.dh.FrqBase=1;		//Bonito ID FrqData01
	myHeadDummy.db.FrqSetDate=today;
	myHeadDummy.db.FrqUserID=0x424F4E49;
	sprintf(myHeadDummy.db.Commentary,"FrqData01 %s Bonito meteorological frequency and schedule list",tim.Format("%d.%b.%Y"));
	mOldData.RemoveAll();
	mNewData.RemoveAll();


	sprintf(buf,"%s\\Data\\FrqConverter\\InputList\\oldFrqData.bin",myDIR);

	fi=fopen(buf,"rb");
	if(fi)
		{
		max=(_filelength(_fileno(fi)))/sizeof(O_FRQLISTDAT);
		mOldData.SetSize(max);
		fread(mOldData.GetData(),sizeof(O_FRQLISTDAT),max,fi);
		fclose(fi);
		}


	sprintf(buf,"%s\\Data\\FrqData01.bin",myDIR);
	fi=fopen(buf,"wb");
	newdat.dh.FrqBase=1;
	newdat.dh.show=1;	

	newdat.db.FrqSetDate=today;
	newdat.db.FrqUserID=0x424F4E49;


	for(i=0; i<max; i++)
		{
		if(mOldData[i].db.decoder !=14336 && mOldData[i].db.decoder!=12545 && mOldData[i].db.decoder!=12546)
			{
			if(!mOldData[i].dh.SchFrameID) continue;
			}

		newdat.dh.SchFrameID=!mOldData[i].dh.SchFrameID;
		meset(&newdat.db,0,sizeof(FRQLISTSET));
		if(i&1) ID+=3;
		else ID+=2;

		newdat.db.FrqSetDate=today;
		newdat.db.FrqUserID=0x424F4E49;
		newdat.db.FrqSetID=ID;


		strncpy(newdat.db.name,OldData[i].db.name,31);
		strncpy(newdat.db.call,OldData[i].db.call,15);
		strncpy(newdat.db.call,OldData[i].db.Commentary,79);

		newdat.db.country=mOldData[i].db.country&0xFFFF;
		newdat.db.modulation=OldData[i].db.modulation&0x1F; ////USB/LSB/AM/FM....
		newdat.db.modulationtype=mOldData[i].db.modulationtype&0x1F;
		newdat.db.stationtype=mOldData[i].db.stationtype&0x1F;
		if(mOldData[i].db.IF==3000) newdat.db.IFBandwidth=2500;
		else newdat.db.IFBandwidth=mOldData[i].db.IFBandwidth;
		newdat.db.frq=mOldData[i].db.frq;
		newdat.db.steps=mOldData[i].db.steps;
		newdat.db.decoder=OldData[i].db.decoder; 
		deco=newdat.db.decoder>>12;
	
		if(mOldData[i].dh.SchFrameID)
			{
			newdat.db.lon=mOldData[i].db.sch.StationsLon;
			newdat.db.lat=mOldData[i].db.sch.StationsLat;
			newdat.db.RegionNr=mOldData[i].db.sch.RegionNr;
			newdat.db.PWR=5000; //500 Watt 0.5 KW
			}

		switch(deco)
			{
			case DEC_FAX:		newdat.db.fax.SatID=mOldData[i].db.SatID;
								newdat.db.fax.modul=mOldData[i].db.FAX_modul;		 
								newdat.db.fax.speed=mOldData[i].db.FAX_speed;		 
								newdat.db.fax.centerfrq=mOldData[i].db.FAX_centerfrq;	 
								newdat.db.fax.shift=mOldData[i].db.FAX_shift;	
								newdat.db.fax.filtermode=mOldData[i].db.FAX_filtermode&7;	
								newdat.db.fax.filterwidth=mOldData[i].db.FAX_filterwidth;
								newdat.db.fax.hmirror=mOldData[i].db.FAX_hmirror&1;
								newdat.db.fax.vmirror=mOldData[i].db.FAX_vmirror&1;	
								newdat.db.fax.amfm=mOldData[i].db.FAX_amfm&1;
								newdat.db.fax.filteronoff=mOldData[i].db.FAX_filteronoff&1;
								newdat.db.fax.burst1=mOldData[i].db.FAX_burst1;	
								newdat.db.fax.burst2=mOldData[i].db.FAX_burst2;
								newdat.db.fax.syncwidth=mOldData[i].db.FAX_syncwidth&0xFF;
								newdat.db.fax.invertsync=mOldData[i].db.FAX_invertsync&1;	
								break;
			case DEC_RTTY:
								newdat.db.rtty.mark=mOldData[i].db.RTTY_mark;
								newdat.db.rtty.space=mOldData[i].db.RTTY_space;
								newdat.db.rtty.mode=mOldData[i].db.RTTY_mode;
								newdat.db.rtty.baud=mOldData[i].db.RTTY_baud;
								if(mOldData[i].db.RTTY_stopbits>1.9) newdat.db.rtty.stopbits=2;
								else {if(mOldData[i].db.RTTY_stopbits>1.4) newdat.db.rtty.stopbits=1;}	
								newdat.db.rtty.polarity=mOldData[i].db.RTTY_polarity&1;
								newdat.db.rtty.RegLetter=mOldData[i].db.NAVTEX_RegLetter;
								//newdat.db.rtty.RegionNr=mOldData[i].db.;
								newdat.db.rtty.shift=mOldData[i].db.;
								newdat.db.rtty.shift=mOldData[i].db.;
								newdat.db.rtty.shift=mOldData[i].db.;
								break

			case DEC_CW:		newdat.db.rtty.cw.center=mOldData[i].db.CW_center;
								newdat.db.rtty.cw.mark=mOldData[i].db.CW_mark;
								newdat.db.rtty.cw.width=mOldData[i].db.width;
								break;
			default:			break;
			}
		

		//char	language[32];
		//char	location[32];
		}

}